// Badge showing contact status as a light-gray icon, such as muted or banned.
import React from 'react';

export default class IconBadges extends React.PureComponent {
  render() {
    if (!Array.isArray(this.props.badges) || this.props.length == 0) {
      return null;
    }
    const mapping = {'muted': 'notifications_off', 'banned': 'block', 'archived': 'archive'};
    const badges = [];
    this.props.badges.map(badge => {
      badges.push(<i className="material-icons light-gray" key={mapping[badge]}>{mapping[badge]}</i>);
    });
    return <React.Fragment>{badges}</React.Fragment>;
};
